<template>
    <div class="box-table__element wow fadeInUp">
        <p class="text-one" :data-label="$t('posts.table.date')">
            {{ formattedDate }}
            <span>{{ formattedTime }}</span>
        </p>
        <p class="text-one nameEdit" :data-label="$t('posts.table.name')">{{ localizedName }}</p>
        <p class="text-one descriptionEdit" :data-label="$t('posts.table.description')">{{ localizedDescription }}</p>
        <p class="text-one" data-label="Картинка" v-if="post.file_url">
            <img class="imagesEdit" :src="post.file_url" alt="">
        </p>
        <p class="text-one">
            <svg>
                <use xlink:href="/img/sprite.svg#eye"></use>
            </svg>

            {{ post.views }}
        </p>
        <p class="text-one">
            <svg class="private" :class="hiddenClass" @click="toggleHidden">
                <use xlink:href="/img/sprite.svg#private"></use>
            </svg>
            <router-link :to="route('posts_edit', {id: post.id})">
                <svg class="edit">
                    <use xlink:href="/img/sprite.svg#edit"></use>
                </svg>
            </router-link>
            <svg class="cancel" @click="$emit('delete-post', post.id)">
                <use xlink:href="/img/sprite.svg#cancel-button"></use>
            </svg>
        </p>
    </div>
</template>

<script>
	import route from "../../mixins/route";
    import {mapGetters} from "vuex";
    import _ from 'lodash';

    export default {
        name: "Post",
        mixins: [route],
        props: ['post'],
        computed: {
            ...mapGetters([
                'locale',
                'axios',
            ]),
            localizedName(){
                return _.get(this.post, 'title.' + this.locale);
            },
            localizedDescription(){
                return _.get(this.post, 'description.' + this.locale);
            },
            formattedDate(){
                return this.$date(this.post.created_at).format('DD.MM.YYYY');
            },
            formattedTime(){
                return this.$date(this.post.created_at).format('HH:mm:ss');
            },
			hiddenClass(){
				return this.post.is_hidden ? 'is-hidden' : ''
			},
        },
		methods: {
			toggleHidden(){
				this.axios
					.post(`posts/${this.post.id}/toggleHidden`)
					.then(({ data }) => {
						console.log(data);
						if(data.status === 'success'){
							this.$swal(data.message);
							this.$emit('updated', data.post);
						}else{
							this.$swal('Неизвестная ошибка');
						}
					})
			}
		}
	}
</script>

<style scoped lang="scss">
.text-one .private.is-hidden {
	fill: #2b5ede !important;

	&:hover {
		fill: #c6c6c6 !important;
	}
}
</style>
